<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"mybatis-3-mapper.dtd">
<mapper namespace="com.mortals.xhx.module.care.dao.ibatis.CareConstraintDaoImpl">

    <!-- 字段和属性映射 -->
    <resultMap type="CareConstraintEntity" id="CareConstraintEntity-Map">
            <id  property="id" column="id" />
            <result property="siteId" column="siteId" />
            <result property="siteName" column="siteName" />
            <result property="personId" column="personId" />
            <result property="name" column="name" />
            <result property="contact" column="contact" />
            <result property="idCard" column="idCard" />
            <result property="serviceFrequency" column="serviceFrequency" />
            <result property="trackingTime" column="trackingTime" />
            <result property="createWay" column="createWay" />
            <result property="operator" column="operator" />
            <result property="track" column="track" />
            <result property="createTime" column="createTime" />
            <result property="createUserId" column="createUserId" />
            <result property="updateTime" column="updateTime" />
            <result property="updateUserId" column="updateUserId" />
            <collection property="careConstraintTrackList" column="id" ofType="CareConstraintTrackEntity" javaType="ArrayList" select="getCareConstraintTrackByCareId"></collection>
    </resultMap>
    <resultMap type="CareConstraintTrackEntity" id="CareConstraintTrackEntity-Map">
            <result property="id" column="id" />
            <result property="careId" column="careId" />
            <result property="feedbackId" column="feedbackId" />
            <result property="feedbackName" column="feedbackName" />
            <result property="feedback" column="feedback" />
            <result property="feedbackTime" column="feedbackTime" />
            <result property="createMethod" column="createMethod" />
            <result property="createTime" column="createTime" />
            <result property="createUserId" column="createUserId" />
            <result property="updateTime" column="updateTime" />
            <result property="updateUserId" column="updateUserId" />
    </resultMap>


    <!-- 表所有列 -->
    <sql id="_columns">
        <trim suffixOverrides="," suffix="">
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('id') or colPickMode == 1 and data.containsKey('id')))">
                    a.id,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('siteId') or colPickMode == 1 and data.containsKey('siteId')))">
                    a.siteId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('siteName') or colPickMode == 1 and data.containsKey('siteName')))">
                    a.siteName,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('personId') or colPickMode == 1 and data.containsKey('personId')))">
                    a.personId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('name') or colPickMode == 1 and data.containsKey('name')))">
                    a.name,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('contact') or colPickMode == 1 and data.containsKey('contact')))">
                    a.contact,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('idCard') or colPickMode == 1 and data.containsKey('idCard')))">
                    a.idCard,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('serviceFrequency') or colPickMode == 1 and data.containsKey('serviceFrequency')))">
                    a.serviceFrequency,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('trackingTime') or colPickMode == 1 and data.containsKey('trackingTime')))">
                    a.trackingTime,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createWay') or colPickMode == 1 and data.containsKey('createWay')))">
                    a.createWay,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('operator') or colPickMode == 1 and data.containsKey('operator')))">
                    a.operator,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('track') or colPickMode == 1 and data.containsKey('track')))">
                    a.track,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createTime') or colPickMode == 1 and data.containsKey('createTime')))">
                    a.createTime,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createUserId') or colPickMode == 1 and data.containsKey('createUserId')))">
                    a.createUserId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateTime') or colPickMode == 1 and data.containsKey('updateTime')))">
                    a.updateTime,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateUserId') or colPickMode == 1 and data.containsKey('updateUserId')))">
                    a.updateUserId,
                </if>
        </trim>
    </sql>
    <!-- 子表所有列 -->
    <sql id="_columns_sub">
        <trim suffixOverrides="," suffix="">
            b.id,b.careId,b.feedbackId,b.feedbackName,b.feedback,b.feedbackTime,b.createMethod,b.createTime,b.createUserId,b.updateTime,b.updateUserId,
        </trim>
    </sql>
    <!-- 新增 区分主键自增加还是业务插入 -->
    <insert id="insert" parameterType="CareConstraintEntity"  useGeneratedKeys="true" keyProperty="id">
        insert into mortals_xhx_care_constraint
        (siteId,siteName,personId,name,contact,idCard,serviceFrequency,trackingTime,createWay,operator,track,createTime,createUserId,updateTime,updateUserId)
        VALUES
        (#{siteId},#{siteName},#{personId},#{name},#{contact},#{idCard},#{serviceFrequency},#{trackingTime},#{createWay},#{operator},#{track},#{createTime},#{createUserId},#{updateTime},#{updateUserId})
    </insert>

    <!-- 批量新增 -->
    <insert id="insertBatch" parameterType="paramDto">
        insert into mortals_xhx_care_constraint
        (siteId,siteName,personId,name,contact,idCard,serviceFrequency,trackingTime,createWay,operator,track,createTime,createUserId,updateTime,updateUserId)
        VALUES
        <foreach collection="data.dataList" item="item" index="index" separator="," >
            (#{item.siteId},#{item.siteName},#{item.personId},#{item.name},#{item.contact},#{item.idCard},#{item.serviceFrequency},#{item.trackingTime},#{item.createWay},#{item.operator},#{item.track},#{item.createTime},#{item.createUserId},#{item.updateTime},#{item.updateUserId})
        </foreach>
    </insert>


    <!-- 根据ParamDto更新 -->
    <update id="update" parameterType="paramDto">
        update mortals_xhx_care_constraint as a
        set
        <trim suffixOverrides="," suffix="">
            <if test="(colPickMode==0 and data.containsKey('siteId')) or (colPickMode==1 and !data.containsKey('siteId'))">
                a.siteId=#{data.siteId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('siteIdIncrement')) or (colPickMode==1 and !data.containsKey('siteIdIncrement'))">
                a.siteId=ifnull(a.siteId,0) + #{data.siteIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('siteName')) or (colPickMode==1 and !data.containsKey('siteName'))">
                a.siteName=#{data.siteName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('personId')) or (colPickMode==1 and !data.containsKey('personId'))">
                a.personId=#{data.personId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('personIdIncrement')) or (colPickMode==1 and !data.containsKey('personIdIncrement'))">
                a.personId=ifnull(a.personId,0) + #{data.personIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('name')) or (colPickMode==1 and !data.containsKey('name'))">
                a.name=#{data.name},
            </if>
            <if test="(colPickMode==0 and data.containsKey('contact')) or (colPickMode==1 and !data.containsKey('contact'))">
                a.contact=#{data.contact},
            </if>
            <if test="(colPickMode==0 and data.containsKey('idCard')) or (colPickMode==1 and !data.containsKey('idCard'))">
                a.idCard=#{data.idCard},
            </if>
            <if test="(colPickMode==0 and data.containsKey('serviceFrequency')) or (colPickMode==1 and !data.containsKey('serviceFrequency'))">
                a.serviceFrequency=#{data.serviceFrequency},
            </if>
            <if test="(colPickMode==0 and data.containsKey('serviceFrequencyIncrement')) or (colPickMode==1 and !data.containsKey('serviceFrequencyIncrement'))">
                a.serviceFrequency=ifnull(a.serviceFrequency,0) + #{data.serviceFrequencyIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('trackingTime')) or (colPickMode==1 and !data.containsKey('trackingTime'))">
                a.trackingTime=#{data.trackingTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createWay')) or (colPickMode==1 and !data.containsKey('createWay'))">
                a.createWay=#{data.createWay},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createWayIncrement')) or (colPickMode==1 and !data.containsKey('createWayIncrement'))">
                a.createWay=ifnull(a.createWay,0) + #{data.createWayIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('operator')) or (colPickMode==1 and !data.containsKey('operator'))">
                a.operator=#{data.operator},
            </if>
            <if test="(colPickMode==0 and data.containsKey('track')) or (colPickMode==1 and !data.containsKey('track'))">
                a.track=#{data.track},
            </if>
            <if test="(colPickMode==0 and data.containsKey('trackIncrement')) or (colPickMode==1 and !data.containsKey('trackIncrement'))">
                a.track=ifnull(a.track,0) + #{data.trackIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createTime')) or (colPickMode==1 and !data.containsKey('createTime'))">
                a.createTime=#{data.createTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createUserId')) or (colPickMode==1 and !data.containsKey('createUserId'))">
                a.createUserId=#{data.createUserId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createUserIdIncrement')) or (colPickMode==1 and !data.containsKey('createUserIdIncrement'))">
                a.createUserId=ifnull(a.createUserId,0) + #{data.createUserIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateTime')) or (colPickMode==1 and !data.containsKey('updateTime'))">
                a.updateTime=#{data.updateTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserId')) or (colPickMode==1 and !data.containsKey('updateUserId'))">
                a.updateUserId=#{data.updateUserId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !data.containsKey('updateUserIdIncrement'))">
                a.updateUserId=ifnull(a.updateUserId,0) + #{data.updateUserIdIncrement},
            </if>
        </trim>
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </update>
    <!-- 批量更新 -->
    <update id="updateBatch" parameterType="paramDto">
        update mortals_xhx_care_constraint as a
        <trim prefix="set" suffixOverrides=",">
                        <trim prefix="siteId=(case" suffix="ELSE siteId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('siteId')) or (colPickMode==1 and !item.containsKey('siteId'))">
                                        when a.id=#{item.id} then #{item.siteId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('siteIdIncrement')) or (colPickMode==1 and !item.containsKey('siteIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.siteId,0) + #{item.siteIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="siteName=(case" suffix="ELSE siteName end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('siteName')) or (colPickMode==1 and !item.containsKey('siteName'))">
                            when a.id=#{item.id} then #{item.siteName}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="personId=(case" suffix="ELSE personId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('personId')) or (colPickMode==1 and !item.containsKey('personId'))">
                                        when a.id=#{item.id} then #{item.personId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('personIdIncrement')) or (colPickMode==1 and !item.containsKey('personIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.personId,0) + #{item.personIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="name=(case" suffix="ELSE name end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('name')) or (colPickMode==1 and !item.containsKey('name'))">
                            when a.id=#{item.id} then #{item.name}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="contact=(case" suffix="ELSE contact end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('contact')) or (colPickMode==1 and !item.containsKey('contact'))">
                            when a.id=#{item.id} then #{item.contact}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="idCard=(case" suffix="ELSE idCard end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('idCard')) or (colPickMode==1 and !item.containsKey('idCard'))">
                            when a.id=#{item.id} then #{item.idCard}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="serviceFrequency=(case" suffix="ELSE serviceFrequency end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('serviceFrequency')) or (colPickMode==1 and !item.containsKey('serviceFrequency'))">
                                        when a.id=#{item.id} then #{item.serviceFrequency}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('serviceFrequencyIncrement')) or (colPickMode==1 and !item.containsKey('serviceFrequencyIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.serviceFrequency,0) + #{item.serviceFrequencyIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="trackingTime=(case" suffix="ELSE trackingTime end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('trackingTime')) or (colPickMode==1 and !item.containsKey('trackingTime'))">
                            when a.id=#{item.id} then #{item.trackingTime}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="createWay=(case" suffix="ELSE createWay end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('createWay')) or (colPickMode==1 and !item.containsKey('createWay'))">
                                        when a.id=#{item.id} then #{item.createWay}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('createWayIncrement')) or (colPickMode==1 and !item.containsKey('createWayIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.createWay,0) + #{item.createWayIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="operator=(case" suffix="ELSE operator end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('operator')) or (colPickMode==1 and !item.containsKey('operator'))">
                            when a.id=#{item.id} then #{item.operator}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="track=(case" suffix="ELSE track end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('track')) or (colPickMode==1 and !item.containsKey('track'))">
                                        when a.id=#{item.id} then #{item.track}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('trackIncrement')) or (colPickMode==1 and !item.containsKey('trackIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.track,0) + #{item.trackIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="createTime=(case" suffix="ELSE createTime end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('createTime')) or (colPickMode==1 and !item.containsKey('createTime'))">
                            when a.id=#{item.id} then #{item.createTime}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="createUserId=(case" suffix="ELSE createUserId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('createUserId')) or (colPickMode==1 and !item.containsKey('createUserId'))">
                                        when a.id=#{item.id} then #{item.createUserId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('createUserIdIncrement')) or (colPickMode==1 and !item.containsKey('createUserIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.createUserId,0) + #{item.createUserIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="updateTime=(case" suffix="ELSE updateTime end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('updateTime')) or (colPickMode==1 and !item.containsKey('updateTime'))">
                            when a.id=#{item.id} then #{item.updateTime}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="updateUserId=(case" suffix="ELSE updateUserId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('updateUserId')) or (colPickMode==1 and !item.containsKey('updateUserId'))">
                                        when a.id=#{item.id} then #{item.updateUserId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !item.containsKey('updateUserIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.updateUserId,0) + #{item.updateUserIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
        </trim>
        where id in
        <foreach collection="data.dataList" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </update>
    <!-- 根据主健查询 -->
    <select id="getByKey" parameterType="paramDto" resultMap="CareConstraintEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_care_constraint as a
        where a.id=#{condition.id}
    </select>
    <!-- 根据主健删除 -->
    <delete id="deleteByKey" parameterType="paramDto">
        delete a.* from mortals_xhx_care_constraint as a where a.id=#{condition.id}
    </delete>
    <!-- 根据主健删除一批，针对单一主健有效 -->
    <delete id="deleteByKeys">
        delete from mortals_xhx_care_constraint where id in
        <foreach collection="array" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>
    <!-- 根据主健列表删除一批，针对单一主健有效 -->
    <delete id="deleteByKeyList">
        delete from mortals_xhx_care_constraint where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>

    <!-- 根据对象列表删除一批，针对单一主健有效 -->
    <delete id="deleteByEntityList">
        delete from mortals_xhx_care_constraint where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </delete>
    <!-- 根据paramDto删除一批 -->
    <delete id="deleteByMap" parameterType="paramDto">
        delete a.* from mortals_xhx_care_constraint as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </delete>
    <!-- 获取列表 -->
    <select id="getList" parameterType="paramDto" resultMap="CareConstraintEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_care_constraint as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
        <include refid="_orderCols_"/>
    </select>
    <!-- 获取子列表 -->
    <select id="getCareConstraintTrackByCareId" parameterType="java.lang.Long" resultMap="CareConstraintTrackEntity-Map">
        select <include refid="_columns_sub"/>
        from mortals_xhx_care_constraint_track as b
        <trim suffixOverrides="where" suffix="">
            where b.careId = #{id}
        </trim>
    </select>



    <!-- 获取 -->
    <select id="getListCount" parameterType="paramDto" resultType="int">
        select count(1)
        from mortals_xhx_care_constraint as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </select>
    <!-- 条件映射 -->
    <sql id="_condition_">
        <if test="condition != null and !condition.isEmpty()">
            <!-- 条件映射-普通条件 -->
            <include refid="_condition_param_">
                <property name="_conditionParam_" value="condition"/>
                <property name="_conditionType_" value="and"/>
            </include>
            <!-- 条件映射-集合之间使用AND，集合中元素使用OR-(list[0].1 or list[0].2) and (list[1].3 or list[1].4) -->
            <if test="condition.containsKey('andConditionList') and !condition.andConditionList.isEmpty()">
                and
                <foreach collection="condition.andConditionList" open="(" close=")" index="index" item="andCondition" separator=" and ">
                    <trim prefixOverrides="or" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="andCondition"/>
                            <property name="_conditionType_" value="or"/>
                        </include>
                    </trim>
                </foreach>
            </if>
            <!-- 条件映射-集合之间使用OR，集合中元素使用AND-(list[0].1 and list[0].2) or (list[1].3 and list[1].4) -->
            <if test="condition.containsKey('orConditionList') and !condition.orConditionList.isEmpty()">
                and
                <foreach collection="condition.orConditionList" open="(" close=")" index="index" item="orCondition" separator=" or ">
                    <trim prefixOverrides="and" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="orCondition"/>
                            <property name="_conditionType_" value="and"/>
                        </include>
                    </trim>
                </foreach>
            </if>
        </if>
    </sql>
    <!-- 条件映射-代参数 -->
    <sql id="_condition_param_">
        <bind name="conditionParamRef" value="${_conditionParam_}"/>
        <if test="conditionParamRef.containsKey('id')">
            <if test="conditionParamRef.id != null">
                ${_conditionType_} a.id=#{${_conditionParam_}.id}
            </if>
        </if>
            <if test="conditionParamRef.containsKey('id')">
                <if test="conditionParamRef.id != null ">
                    ${_conditionType_} a.id = #{${_conditionParam_}.id}
                </if>
                <if test="conditionParamRef.id == null">
                    ${_conditionType_} a.id is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('idList') and conditionParamRef.idList.size() > 0">
                ${_conditionType_} a.id in
                <foreach collection="conditionParamRef.idList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('idNotList') and conditionParamRef.idNotList.size() > 0">
                ${_conditionType_} a.id not in
                <foreach collection="conditionParamRef.idNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('idStart') and conditionParamRef.idStart != null">
                ${_conditionType_} a.id <![CDATA[ >= ]]> #{${_conditionParam_}.idStart}
            </if>
            <if test="conditionParamRef.containsKey('idEnd') and conditionParamRef.idEnd != null">
                ${_conditionType_} a.id <![CDATA[ <= ]]> #{${_conditionParam_}.idEnd}
            </if>

            <if test="conditionParamRef.containsKey('siteId')">
                <if test="conditionParamRef.siteId != null ">
                    ${_conditionType_} a.siteId = #{${_conditionParam_}.siteId}
                </if>
                <if test="conditionParamRef.siteId == null">
                    ${_conditionType_} a.siteId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('siteIdList') and conditionParamRef.siteIdList.size() > 0">
                ${_conditionType_} a.siteId in
                <foreach collection="conditionParamRef.siteIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('siteIdNotList') and conditionParamRef.siteIdNotList.size() > 0">
                ${_conditionType_} a.siteId not in
                <foreach collection="conditionParamRef.siteIdNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('siteIdStart') and conditionParamRef.siteIdStart != null">
                ${_conditionType_} a.siteId <![CDATA[ >= ]]> #{${_conditionParam_}.siteIdStart}
            </if>
            <if test="conditionParamRef.containsKey('siteIdEnd') and conditionParamRef.siteIdEnd != null">
                ${_conditionType_} a.siteId <![CDATA[ <= ]]> #{${_conditionParam_}.siteIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('siteName')">
                <if test="conditionParamRef.siteName != null and conditionParamRef.siteName != ''">
                    ${_conditionType_} a.siteName like #{${_conditionParam_}.siteName}
                </if>
                <if test="conditionParamRef.siteName == null">
                    ${_conditionType_} a.siteName is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('siteNameList') and conditionParamRef.siteNameList.size() > 0">
                ${_conditionType_} a.siteName in
                <foreach collection="conditionParamRef.siteNameList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('siteNameNotList') and conditionParamRef.siteNameNotList.size() > 0">
                ${_conditionType_} a.siteName not in
                <foreach collection="conditionParamRef.siteNameNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('personId')">
                <if test="conditionParamRef.personId != null ">
                    ${_conditionType_} a.personId = #{${_conditionParam_}.personId}
                </if>
                <if test="conditionParamRef.personId == null">
                    ${_conditionType_} a.personId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('personIdList') and conditionParamRef.personIdList.size() > 0">
                ${_conditionType_} a.personId in
                <foreach collection="conditionParamRef.personIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('personIdNotList') and conditionParamRef.personIdNotList.size() > 0">
                ${_conditionType_} a.personId not in
                <foreach collection="conditionParamRef.personIdNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('personIdStart') and conditionParamRef.personIdStart != null">
                ${_conditionType_} a.personId <![CDATA[ >= ]]> #{${_conditionParam_}.personIdStart}
            </if>
            <if test="conditionParamRef.containsKey('personIdEnd') and conditionParamRef.personIdEnd != null">
                ${_conditionType_} a.personId <![CDATA[ <= ]]> #{${_conditionParam_}.personIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('name')">
                <if test="conditionParamRef.name != null and conditionParamRef.name != ''">
                    ${_conditionType_} a.name like #{${_conditionParam_}.name}
                </if>
                <if test="conditionParamRef.name == null">
                    ${_conditionType_} a.name is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('nameList') and conditionParamRef.nameList.size() > 0">
                ${_conditionType_} a.name in
                <foreach collection="conditionParamRef.nameList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('nameNotList') and conditionParamRef.nameNotList.size() > 0">
                ${_conditionType_} a.name not in
                <foreach collection="conditionParamRef.nameNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('contact')">
                <if test="conditionParamRef.contact != null and conditionParamRef.contact != ''">
                    ${_conditionType_} a.contact like #{${_conditionParam_}.contact}
                </if>
                <if test="conditionParamRef.contact == null">
                    ${_conditionType_} a.contact is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('contactList') and conditionParamRef.contactList.size() > 0">
                ${_conditionType_} a.contact in
                <foreach collection="conditionParamRef.contactList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('contactNotList') and conditionParamRef.contactNotList.size() > 0">
                ${_conditionType_} a.contact not in
                <foreach collection="conditionParamRef.contactNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('idCard')">
                <if test="conditionParamRef.idCard != null and conditionParamRef.idCard != ''">
                    ${_conditionType_} a.idCard like #{${_conditionParam_}.idCard}
                </if>
                <if test="conditionParamRef.idCard == null">
                    ${_conditionType_} a.idCard is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('idCardList') and conditionParamRef.idCardList.size() > 0">
                ${_conditionType_} a.idCard in
                <foreach collection="conditionParamRef.idCardList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('idCardNotList') and conditionParamRef.idCardNotList.size() > 0">
                ${_conditionType_} a.idCard not in
                <foreach collection="conditionParamRef.idCardNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('serviceFrequency')">
                <if test="conditionParamRef.serviceFrequency != null ">
                    ${_conditionType_} a.serviceFrequency = #{${_conditionParam_}.serviceFrequency}
                </if>
                <if test="conditionParamRef.serviceFrequency == null">
                    ${_conditionType_} a.serviceFrequency is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('serviceFrequencyList') and conditionParamRef.serviceFrequencyList.size() > 0">
                ${_conditionType_} a.serviceFrequency in
                <foreach collection="conditionParamRef.serviceFrequencyList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('serviceFrequencyNotList') and conditionParamRef.serviceFrequencyNotList.size() > 0">
                ${_conditionType_} a.serviceFrequency not in
                <foreach collection="conditionParamRef.serviceFrequencyNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('serviceFrequencyStart') and conditionParamRef.serviceFrequencyStart != null">
                ${_conditionType_} a.serviceFrequency <![CDATA[ >= ]]> #{${_conditionParam_}.serviceFrequencyStart}
            </if>
            <if test="conditionParamRef.containsKey('serviceFrequencyEnd') and conditionParamRef.serviceFrequencyEnd != null">
                ${_conditionType_} a.serviceFrequency <![CDATA[ <= ]]> #{${_conditionParam_}.serviceFrequencyEnd}
            </if>


            <if test="conditionParamRef.containsKey('trackingTime')">
                <if test="conditionParamRef.trackingTime != null ">
                    ${_conditionType_} a.trackingTime = #{${_conditionParam_}.trackingTime}
                </if>
                <if test="conditionParamRef.trackingTime == null">
                    ${_conditionType_} a.trackingTime is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('trackingTimeStart') and conditionParamRef.trackingTimeStart != null and conditionParamRef.trackingTimeStart!=''">
                ${_conditionType_} a.trackingTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.trackingTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('trackingTimeEnd') and conditionParamRef.trackingTimeEnd != null and conditionParamRef.trackingTimeEnd!=''">
                ${_conditionType_} a.trackingTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.trackingTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('createWay')">
                <if test="conditionParamRef.createWay != null ">
                    ${_conditionType_} a.createWay = #{${_conditionParam_}.createWay}
                </if>
                <if test="conditionParamRef.createWay == null">
                    ${_conditionType_} a.createWay is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('createWayList') and conditionParamRef.createWayList.size() > 0">
                ${_conditionType_} a.createWay in
                <foreach collection="conditionParamRef.createWayList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('createWayNotList') and conditionParamRef.createWayNotList.size() > 0">
                ${_conditionType_} a.createWay not in
                <foreach collection="conditionParamRef.createWayNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('createWayStart') and conditionParamRef.createWayStart != null">
                ${_conditionType_} a.createWay <![CDATA[ >= ]]> #{${_conditionParam_}.createWayStart}
            </if>
            <if test="conditionParamRef.containsKey('createWayEnd') and conditionParamRef.createWayEnd != null">
                ${_conditionType_} a.createWay <![CDATA[ <= ]]> #{${_conditionParam_}.createWayEnd}
            </if>


            <if test="conditionParamRef.containsKey('operator')">
                <if test="conditionParamRef.operator != null and conditionParamRef.operator != ''">
                    ${_conditionType_} a.operator like #{${_conditionParam_}.operator}
                </if>
                <if test="conditionParamRef.operator == null">
                    ${_conditionType_} a.operator is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('operatorList') and conditionParamRef.operatorList.size() > 0">
                ${_conditionType_} a.operator in
                <foreach collection="conditionParamRef.operatorList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('operatorNotList') and conditionParamRef.operatorNotList.size() > 0">
                ${_conditionType_} a.operator not in
                <foreach collection="conditionParamRef.operatorNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('track')">
                <if test="conditionParamRef.track != null ">
                    ${_conditionType_} a.track = #{${_conditionParam_}.track}
                </if>
                <if test="conditionParamRef.track == null">
                    ${_conditionType_} a.track is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('trackList') and conditionParamRef.trackList.size() > 0">
                ${_conditionType_} a.track in
                <foreach collection="conditionParamRef.trackList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('trackNotList') and conditionParamRef.trackNotList.size() > 0">
                ${_conditionType_} a.track not in
                <foreach collection="conditionParamRef.trackNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('trackStart') and conditionParamRef.trackStart != null">
                ${_conditionType_} a.track <![CDATA[ >= ]]> #{${_conditionParam_}.trackStart}
            </if>
            <if test="conditionParamRef.containsKey('trackEnd') and conditionParamRef.trackEnd != null">
                ${_conditionType_} a.track <![CDATA[ <= ]]> #{${_conditionParam_}.trackEnd}
            </if>


            <if test="conditionParamRef.containsKey('createTime')">
                <if test="conditionParamRef.createTime != null ">
                    ${_conditionType_} a.createTime = #{${_conditionParam_}.createTime}
                </if>
                <if test="conditionParamRef.createTime == null">
                    ${_conditionType_} a.createTime is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('createTimeStart') and conditionParamRef.createTimeStart != null and conditionParamRef.createTimeStart!=''">
                ${_conditionType_} a.createTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('createTimeEnd') and conditionParamRef.createTimeEnd != null and conditionParamRef.createTimeEnd!=''">
                ${_conditionType_} a.createTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('createUserId')">
                <if test="conditionParamRef.createUserId != null ">
                    ${_conditionType_} a.createUserId = #{${_conditionParam_}.createUserId}
                </if>
                <if test="conditionParamRef.createUserId == null">
                    ${_conditionType_} a.createUserId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('createUserIdList') and conditionParamRef.createUserIdList.size() > 0">
                ${_conditionType_} a.createUserId in
                <foreach collection="conditionParamRef.createUserIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('createUserIdNotList') and conditionParamRef.createUserIdNotList.size() > 0">
                ${_conditionType_} a.createUserId not in
                <foreach collection="conditionParamRef.createUserIdNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('createUserIdStart') and conditionParamRef.createUserIdStart != null">
                ${_conditionType_} a.createUserId <![CDATA[ >= ]]> #{${_conditionParam_}.createUserIdStart}
            </if>
            <if test="conditionParamRef.containsKey('createUserIdEnd') and conditionParamRef.createUserIdEnd != null">
                ${_conditionType_} a.createUserId <![CDATA[ <= ]]> #{${_conditionParam_}.createUserIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('updateTime')">
                <if test="conditionParamRef.updateTime != null ">
                    ${_conditionType_} a.updateTime = #{${_conditionParam_}.updateTime}
                </if>
                <if test="conditionParamRef.updateTime == null">
                    ${_conditionType_} a.updateTime is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('updateTimeStart') and conditionParamRef.updateTimeStart != null and conditionParamRef.updateTimeStart!=''">
                ${_conditionType_} a.updateTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('updateTimeEnd') and conditionParamRef.updateTimeEnd != null and conditionParamRef.updateTimeEnd!=''">
                ${_conditionType_} a.updateTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('updateUserId')">
                <if test="conditionParamRef.updateUserId != null ">
                    ${_conditionType_} a.updateUserId = #{${_conditionParam_}.updateUserId}
                </if>
                <if test="conditionParamRef.updateUserId == null">
                    ${_conditionType_} a.updateUserId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdList') and conditionParamRef.updateUserIdList.size() > 0">
                ${_conditionType_} a.updateUserId in
                <foreach collection="conditionParamRef.updateUserIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdNotList') and conditionParamRef.updateUserIdNotList.size() > 0">
                ${_conditionType_} a.updateUserId not in
                <foreach collection="conditionParamRef.updateUserIdNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdStart') and conditionParamRef.updateUserIdStart != null">
                ${_conditionType_} a.updateUserId <![CDATA[ >= ]]> #{${_conditionParam_}.updateUserIdStart}
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdEnd') and conditionParamRef.updateUserIdEnd != null">
                ${_conditionType_} a.updateUserId <![CDATA[ <= ]]> #{${_conditionParam_}.updateUserIdEnd}
            </if>

    </sql>
    <sql id="_orderCols_">
        <if test="orderColList != null and !orderColList.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                <foreach collection="orderColList" open="" close="" index="index" item="item" separator=",">
                     ${item.colName} ${item.sortKind}
                </foreach>
            </trim>
        </if>
        <if test="(orderColList == null or orderColList.isEmpty()) and orderCol != null and !orderCol.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                    <if test="orderCol.containsKey('id')">
                        a.id
                        <if test='orderCol.id != null and "DESC".equalsIgnoreCase(orderCol.id)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('siteId')">
                        a.siteId
                        <if test='orderCol.siteId != null and "DESC".equalsIgnoreCase(orderCol.siteId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('siteName')">
                        a.siteName
                        <if test='orderCol.siteName != null and "DESC".equalsIgnoreCase(orderCol.siteName)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('personId')">
                        a.personId
                        <if test='orderCol.personId != null and "DESC".equalsIgnoreCase(orderCol.personId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('name')">
                        a.name
                        <if test='orderCol.name != null and "DESC".equalsIgnoreCase(orderCol.name)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('contact')">
                        a.contact
                        <if test='orderCol.contact != null and "DESC".equalsIgnoreCase(orderCol.contact)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('idCard')">
                        a.idCard
                        <if test='orderCol.idCard != null and "DESC".equalsIgnoreCase(orderCol.idCard)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('serviceFrequency')">
                        a.serviceFrequency
                        <if test='orderCol.serviceFrequency != null and "DESC".equalsIgnoreCase(orderCol.serviceFrequency)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('trackingTime')">
                        a.trackingTime
                        <if test='orderCol.trackingTime != null and "DESC".equalsIgnoreCase(orderCol.trackingTime)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('createWay')">
                        a.createWay
                        <if test='orderCol.createWay != null and "DESC".equalsIgnoreCase(orderCol.createWay)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('operator')">
                        a.operator
                        <if test='orderCol.operator != null and "DESC".equalsIgnoreCase(orderCol.operator)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('track')">
                        a.track
                        <if test='orderCol.track != null and "DESC".equalsIgnoreCase(orderCol.track)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('createTime')">
                        a.createTime
                        <if test='orderCol.createTime != null and "DESC".equalsIgnoreCase(orderCol.createTime)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('createUserId')">
                        a.createUserId
                        <if test='orderCol.createUserId != null and "DESC".equalsIgnoreCase(orderCol.createUserId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('updateTime')">
                        a.updateTime
                        <if test='orderCol.updateTime != null and "DESC".equalsIgnoreCase(orderCol.updateTime)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('updateUserId')">
                        a.updateUserId
                        <if test='orderCol.updateUserId != null and "DESC".equalsIgnoreCase(orderCol.updateUserId)'>DESC</if>
                        ,
                    </if>
            </trim>
        </if>
    </sql>
    <sql id="_group_by_">
        <if test="groupList != null and !groupList.isEmpty()">
            GROUP BY
            <trim suffixOverrides=","  suffix="">
                <foreach collection="groupList" open="" close="" index="index" item="item" separator=",">
                    ${item}
                </foreach>
            </trim>
        </if>
    </sql>
</mapper>